/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.spass.components;

import javax.swing.table.AbstractTableModel;

/**
 *
 * @author shuu
 */
public class SlinkPassTableModel extends AbstractTableModel {
    private static final long serialVersionUID = 1L;

    private String[][] mRows;
    private String[]   mCols;
    private Class<?>[] mTyps;
    private boolean mEditable;

    public SlinkPassTableModel(String[][] rows, String[] cols, Class<?>[] typs, boolean editable) {
        this.mRows = rows;
        this.mCols = cols;
        this.mTyps = typs;
        this.mEditable = editable;
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return mEditable && columnIndex == 1;
    }

    @Override
    public int getColumnCount() {
        return mCols.length;
    }

    @Override
    public int getRowCount() {
        return mRows.length;
    }

    @Override
    public String getColumnName(int columnIndex) {
        return mCols[columnIndex];
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        return mTyps[columnIndex];
    }

    @Override
    public Object getValueAt(final int rowIndex, final int columnIndex) {
        switch (columnIndex) {
            case 0:
                // 表示
                return mRows[rowIndex][1];
            default:
                // 操作
                String[] data = new String[mRows[rowIndex].length];
                System.arraycopy(mRows[rowIndex], 0, data, 0, mRows[rowIndex].length);
                return data;
        }
    }

}
