/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.spass.components;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.AbstractCellEditor;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;
import jp.co.secioss.spass.SlinkTabPanelAbstract;

/**
 *
 * @author shuu
 */
public class SlinkPassTableCellEditorAndRenderer extends AbstractCellEditor implements TableCellRenderer, TableCellEditor {
    private static final long serialVersionUID = 1L;

    private Object mObject;
    private JPanel mOldPanel;
    private JPanel mNewPanel;

    public SlinkPassTableCellEditorAndRenderer(final SlinkTabPanelAbstract tab) {
        // 既存
        mOldPanel = new SlinkPassOperationOldPanel();
        JButton btn0 = (JButton) mOldPanel.getComponent(0);
        btn0.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                fireEditingStopped();
                String[] data = (String[]) mObject;
                tab.doEdit(data);
            }
        });
        JButton btn1 = (JButton) mOldPanel.getComponent(1);
        btn1.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                fireEditingStopped();
                String[] data = (String[]) mObject;
                tab.doDele(data);
            }
        });
        JButton btn2 = (JButton) mOldPanel.getComponent(2);
        btn2.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                fireEditingStopped();
                String[] data = (String[]) mObject;
                tab.doOpen(data);
            }
        });

        // 新規
        mNewPanel = new SlinkPassOperationNewPanel();
        JButton btn3 = (JButton) mNewPanel.getComponent(0);
        btn3.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                fireEditingStopped();
                String[] data = (String[]) mObject;
                tab.doEdit(data);
            }
        });
    }

    @Override
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
        return getTableCellComponent(table, value, isSelected, hasFocus, row, column);
    }

    @Override
    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
        return getTableCellComponent(table, value, isSelected, false, row, column);
    }

    @Override
    public Object getCellEditorValue() {
        return null;
    }

    private Component getTableCellComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
        if (column == 1) {
            mObject = value;
            if (row == table.getRowCount() - 1) {
                if (row%2 == 0) {
                    mNewPanel.setBackground(new java.awt.Color(255, 255, 255));
                }
                else {
                    mNewPanel.setBackground(new java.awt.Color(240, 240, 240));
                }
                return mNewPanel;
            }

            if (row%2 == 0) {
                mOldPanel.setBackground(new java.awt.Color(255, 255, 255));
            }
            else {
                mOldPanel.setBackground(new java.awt.Color(240, 240, 240));
            }
            return mOldPanel;
        }
        else {
            String str = null == value ? "" : "  " + value;
            JLabel label = new JLabel(str);
            label.setOpaque(true);
            if (row%2 == 0) {
                label.setBackground(new java.awt.Color(255, 255, 255));
            }
            else {
                label.setBackground(new java.awt.Color(240, 240, 240));
            }
            return label;
        }
    }

}
